diff --git a/contrib/generate.py b/contrib/generate.py
index 0d3c0b7fa..c2c992eb8 100755
--- a/contrib/generate.py
+++ b/contrib/generate.py
@@ -859,7 +859,6 @@ def write_torrc_files(auths):
 AllowInvalidNodes "entry,middle,exit,introduction,rendezvous"\n\
 ServerDNSDetectHijacking 0\n\
 NumCPUs 1\n\
-Log notice stdout\n\
 SafeLogging 0\n\
 WarnUnsafeSocks 0\n\
 ContactInfo shadow-support@cs.umn.edu\n\
diff --git a/src/plugins/scallion/shd-scallion-preload.c b/src/plugins/scallion/shd-scallion-preload.c
index a557dc6bd..ec08798ef 100644
--- a/src/plugins/scallion/shd-scallion-preload.c
+++ b/src/plugins/scallion/shd-scallion-preload.c
@@ -32,12 +32,10 @@
 
 typedef int (*tor_open_socket_fp)(int, int, int);
 typedef int (*tor_gettimeofday_fp)(struct timeval *);
-typedef void (*logv_fp)();
 typedef int (*spawn_func_fp)();
 typedef int (*rep_hist_bandwidth_assess_fp)();
 typedef int (*router_get_advertised_bandwidth_capped_fp)(void*);
 typedef int (*event_base_loopexit_fp)();
-typedef int (*add_callback_log_fp)(const log_severity_list_t *, log_callback);
 typedef int (*crypto_global_cleanup_fp)(void);
 
 /* the key used to store each threads version of their searched function library.
@@ -51,13 +49,11 @@ struct _ScallionPreloadWorker {
 	GModule* handle;
 	tor_open_socket_fp a;
 	tor_gettimeofday_fp b;
-	logv_fp c;
 	spawn_func_fp d;
 	rep_hist_bandwidth_assess_fp e;
 	router_get_advertised_bandwidth_capped_fp f;
 	event_base_loopexit_fp g;
-	add_callback_log_fp h;
-	crypto_global_cleanup_fp i;
+	crypto_global_cleanup_fp h;
 };
 
 /* scallionpreload_init must be called before this so the worker gets created */
@@ -87,13 +83,11 @@ void scallionpreload_init(GModule* handle) {
 	/* lookup all our required symbols in this worker's module, asserting success */
 	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "tor_open_socket", (gpointer*)&(worker->a)));
 	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "tor_gettimeofday", (gpointer*)&(worker->b)));
-	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "logv", (gpointer*)&(worker->c)));
 	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "spawn_func", (gpointer*)&(worker->d)));
 	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "rep_hist_bandwidth_assess", (gpointer*)&(worker->e)));
 	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "router_get_advertised_bandwidth_capped", (gpointer*)&(worker->f)));
 	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "event_base_loopexit", (gpointer*)&(worker->g)));
-	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "add_callback_log", (gpointer*)&(worker->h)));
-	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "crypto_global_cleanup", (gpointer*)&(worker->i)));
+	g_assert(g_module_symbol(handle, TOR_LIB_PREFIX "crypto_global_cleanup", (gpointer*)&(worker->h)));
 
 	g_static_private_set(&scallionWorkerKey, worker, g_free);
 }
@@ -106,18 +100,6 @@ void tor_gettimeofday(struct timeval *timeval) {
 	_scallionpreload_getWorker()->b(timeval);
 }
 
-#ifdef SCALLION_LOGVWITHSUFFIX
-void logv(int severity, uint32_t domain, const char *funcname,
-	const char *suffix, const char *format, va_list ap) {
-	_scallionpreload_getWorker()->c(severity, domain, funcname, suffix, format, ap);
-}
-#else
-void logv(int severity, uint32_t domain, const char *funcname,
-    const char *format, va_list ap) {
-	_scallionpreload_getWorker()->c(severity, domain, funcname, format, ap);
-}
-#endif
-
 int spawn_func(void (*func)(void *), void *data) {
 	return _scallionpreload_getWorker()->d(func, data);
 }
@@ -135,10 +117,6 @@ int event_base_loopexit(gpointer base, const struct timeval * t) {
 	return _scallionpreload_getWorker()->g(base, t);
 }
 
-int add_callback_log(const log_severity_list_t *severity, log_callback cb) {
-    return _scallionpreload_getWorker()->h(severity, cb);
-}
-
 int crypto_global_cleanup(void) {
-	return _scallionpreload_getWorker()->i();
+	return _scallionpreload_getWorker()->h();
 }
diff --git a/src/plugins/scallion/shd-scallion.c b/src/plugins/scallion/shd-scallion.c
index 5ac289d93..7fdce3e01 100644
--- a/src/plugins/scallion/shd-scallion.c
+++ b/src/plugins/scallion/shd-scallion.c
@@ -143,6 +143,44 @@ static void _scalliontor_refillCallback(ScallionTor* stor) {
 }
 #endif
 
+static ScallionTor* scalliontor_getPointer() {
+	return scallion.stor;
+}
+
+static void scalliontor_logmsg_cb(int severity, uint32_t domain, const char *msg) {
+	GLogLevelFlags level;
+	switch (severity) {
+		case LOG_DEBUG:
+			level = G_LOG_LEVEL_DEBUG;
+		break;
+		case LOG_INFO:
+			level = G_LOG_LEVEL_INFO;
+		break;
+		case LOG_NOTICE:
+			level = G_LOG_LEVEL_MESSAGE;
+		break;
+		case LOG_WARN:
+			level = G_LOG_LEVEL_WARNING;
+		break;
+		case LOG_ERR:
+			level = G_LOG_LEVEL_ERROR;
+		break;
+		default:
+			level = G_LOG_LEVEL_DEBUG;
+		break;
+	}
+	scalliontor_getPointer()->shadowlibFuncs->log(level, __FUNCTION__, g_strchomp(msg));
+}
+
+static void scalliontor_setLogging() {
+	/* setup a callback so we can log into shadow */
+    log_severity_list_t *severity = g_new0(log_severity_list_t, 1);
+    /* we'll log everything according to Shadow's filter */
+    set_log_severity_config(LOG_DEBUG, LOG_ERR, severity);
+    add_callback_log(severity, scalliontor_logmsg_cb);
+    g_free(severity);
+}
+
 gint scalliontor_start(ScallionTor* stor, gint argc, gchar *argv[]) {
 	time_t now = time(NULL);
 
@@ -150,9 +188,12 @@ gint scalliontor_start(ScallionTor* stor, gint argc, gchar *argv[]) {
 	tor_threads_init();
 	init_logging();
 
+	/* tor_init() loses our logging, so set it before AND after */
+	scalliontor_setLogging();
 	if (tor_init(argc, argv) < 0) {
 		return -1;
 	}
+	scalliontor_setLogging();
 
 	  /* load the private keys, if we're supposed to have them, and set up the
 	   * TLS context. */
@@ -275,20 +316,21 @@ ScallionTor* scalliontor_new(ShadowFunctionTable* shadowlibFuncs, char* hostname
 	GString* geoipBuffer = _scalliontor_getHomePath(geoip_path);
 
 	/* default args */
-	char *config[25];
+	char *config[26];
 	config[0] = "tor";
-	config[1] = "--Address";
-	config[2] = hostname;
-	config[3] = "-f";
-	config[4] = torrcBuffer->str;
-	config[5] = "--DataDirectory";
-	config[6] = datadirBuffer->str;
-	config[7] = "--GeoIPFile";
-	config[8] = geoipBuffer->str;
-	config[9] = "--BandwidthRate";
-	config[10] = bwrate;
-	config[11] = "--BandwidthBurst";
-	config[12] = bwburst;
+	config[1] = "--quiet";
+	config[2] = "--Address";
+	config[3] = hostname;
+	config[4] = "-f";
+	config[5] = torrcBuffer->str;
+	config[6] = "--DataDirectory";
+	config[7] = datadirBuffer->str;
+	config[8] = "--GeoIPFile";
+	config[9] = geoipBuffer->str;
+	config[10] = "--BandwidthRate";
+	config[11] = bwrate;
+	config[12] = "--BandwidthBurst";
+	config[13] = bwburst;
 
 	gchar* nickname = g_strdup(hostname);
 	while(1) {
@@ -300,19 +342,19 @@ ScallionTor* scalliontor_new(ShadowFunctionTable* shadowlibFuncs, char* hostname
 		}
 	}
 
-	config[13] = "--Nickname";
-	config[14] = nickname;
+	config[14] = "--Nickname";
+	config[15] = nickname;
 
-	config[15] = "--ControlPort";
-    config[16] = "9051";
-    config[17] = "--ControlListenAddress";
-    config[18] = "127.0.0.1";
-    config[19] = "--ControlListenAddress";
-    config[20] = hostname;
-    config[21] = "HashedControlPassword";
-    config[22] = "16:25662F13DA7881D46091AB96726A8E5245CBF98BA6961A5B8C9CEEBB25";
+	config[16] = "--ControlPort";
+    config[17] = "9051";
+    config[18] = "--ControlListenAddress";
+    config[19] = "127.0.0.1";
+    config[20] = "--ControlListenAddress";
+    config[21] = hostname;
+    config[22] = "HashedControlPassword";
+    config[23] = "16:25662F13DA7881D46091AB96726A8E5245CBF98BA6961A5B8C9CEEBB25";
 
-	int num_args = 23;
+	int num_args = 24;
 	/* additional args */
 	if(stor->type == VTOR_DIRAUTH) {
 		num_args += 2;
@@ -320,8 +362,8 @@ ScallionTor* scalliontor_new(ShadowFunctionTable* shadowlibFuncs, char* hostname
 			stor->shadowlibFuncs->log(G_LOG_LEVEL_MESSAGE, __FUNCTION__,
 					"data directory path is too long and was truncated to '%s'\n", stor->v3bw_name);
 		}
-		config[23] = "--V3BandwidthsFile";
-		config[24] = stor->v3bw_name;
+		config[24] = "--V3BandwidthsFile";
+		config[25] = stor->v3bw_name;
 	}
 
 	scallion.stor = stor;
@@ -774,10 +816,6 @@ void scalliontor_newCPUWorker(ScallionTor* stor, int fd) {
 	event_add(&(cpuw->read_event), NULL);
 }
 
-static ScallionTor* scalliontor_getPointer() {
-	return scallion.stor;
-}
-
 /*
  * Tor function interceptions
  */
@@ -809,99 +847,6 @@ void intercept_tor_gettimeofday(struct timeval *timeval) {
 	timeval->tv_usec = tp.tv_nsec/1000;
 }
 
-#ifdef SCALLION_LOGVWITHSUFFIX
-void intercept_logv(int severity, uint32_t domain, const char *funcname,
-     const char *suffix, const char *format, va_list ap) {
-#else
-void intercept_logv(int severity, uint32_t domain, const char *funcname,
-     const char *format, va_list ap) {
-#endif
-	char* sev_str = NULL;
-	const size_t buflen = 10024;
-	char buf[buflen];
-	size_t current_position = 0;
-
-	/* Call assert, not tor_assert, since tor_assert calls log on failure. */
-	assert(format);
-
-	GLogLevelFlags level;
-
-	switch (severity) {
-		case LOG_DEBUG:
-			sev_str = "debug";
-			level = G_LOG_LEVEL_DEBUG;
-		break;
-
-		case LOG_INFO:
-			sev_str = "info";
-			level = G_LOG_LEVEL_INFO;
-		break;
-
-		case LOG_NOTICE:
-			sev_str = "notice";
-			level = G_LOG_LEVEL_MESSAGE;
-		break;
-
-		case LOG_WARN:
-			sev_str = "warn";
-			level = G_LOG_LEVEL_WARNING;
-		break;
-
-		case LOG_ERR:
-			sev_str = "err";
-			level = G_LOG_LEVEL_ERROR;
-		break;
-
-		default:
-			sev_str = "UNKNOWN";
-			level = G_LOG_LEVEL_DEBUG;
-		break;
-	}
-
-	snprintf(&buf[current_position], strlen(sev_str)+4, "[%s] ", sev_str);
-	current_position += strlen(sev_str)+3;
-
-	if (domain == LD_BUG) {
-		snprintf(&buf[current_position], 6, "BUG: ");
-		current_position += 5;
-	}
-
-	if(funcname != NULL) {
-		snprintf(&buf[current_position], strlen(funcname)+4, "%s() ", funcname);
-		current_position += strlen(funcname)+3;
-	}
-
-	size_t size = buflen-current_position-2;
-	int res = vsnprintf(&buf[current_position], size, format, ap);
-
-	if(res >= size) {
-		/* truncated */
-		current_position = buflen - 3;
-	} else {
-		current_position += res;
-#ifdef SCALLION_LOGVWITHSUFFIX
-	    if (suffix) {
-	      size_t suffix_len = strlen(suffix);
-	      if (buflen-current_position >= suffix_len) {
-	        snprintf(&buf[current_position], suffix_len+1, "%s", suffix);
-	        current_position += suffix_len;
-	      }
-	    }
-#endif
-	}
-
-	buf[current_position] = '\0';
-	current_position++;
-
-	ScallionTor* stor = scalliontor_getPointer();
-	stor->shadowlibFuncs->log(level, __FUNCTION__, buf);
-
-	for(GList *iter = stor->logfiles; iter; iter = g_list_next(iter)) {
-        vtor_logfile_tp lf = iter->data;
-        lf->callback(severity, domain, buf);
-    }
-}
-
 int intercept_spawn_func(void (*func)(void *), void *data)
 {
 	ScallionTor* stor = scalliontor_getPointer();
@@ -936,21 +881,6 @@ uint32_t intercept_router_get_advertised_bandwidth_capped(const routerinfo_t *ro
   return router->bandwidthcapacity;
 }
 
-/* for the tor control, need to know all the callbacks where log messages get sent */
-int intercept_add_callback_log(const log_severity_list_t *severity, log_callback cb) {
-    ScallionTor* stor = scalliontor_getPointer();
-    g_assert(stor);
-
-    vtor_logfile_tp lf = g_new0(vtor_logfile_t, 1);
-    lf->fd = -1;
-    lf->severities = g_memdup(severity, sizeof(log_severity_list_t));
-    lf->callback = cb;
-
-    stor->logfiles = g_list_append(stor->logfiles, lf);
-
-    return 0;
-}
-
 int intercept_crypto_global_cleanup(void) {
 	/* FIXME: we need to clean up all of the node-specific state while only
 	 * calling the global openssl cleanup funcs once.
diff --git a/src/plugins/scallion/shd-scallion.h b/src/plugins/scallion/shd-scallion.h
index a06ab56d4..e3364374f 100644
--- a/src/plugins/scallion/shd-scallion.h
+++ b/src/plugins/scallion/shd-scallion.h
@@ -257,7 +257,6 @@ struct _ScallionTor {
 	unsigned int bandwidth;
 	int refillmsecs;
 	vtor_cpuworker_tp cpuw;
-	GList *logfiles;
 	ShadowFunctionTable* shadowlibFuncs;
 };
 
